from flask_login import current_user
from flask import request

from app.utils.render import render
from app.forms.forum import TopicCreationForm
from app.models.forum import Forum
from app.models.topic import Topic
from app.models.thread import Thread
from app.models.comment import Comment
from app import app, db

@app.route('/forum/')
def forum_index():
    main_forum = Forum.query.filter_by(parent=None).first()
    return render('/forum/index.html', main_forum=main_forum)

@app.route('/forum/<forum:f>/', methods=['GET', 'POST'])
def forum_page(f):
    form = TopicCreationForm()

    if form.validate_on_submit():
        # TODO: Check user privileges for this specific forum!

        # First create the thread, then the comment, then the topic
        th = Thread()
        db.session.add(th)
        db.session.commit()

        c = Comment(current_user, form.message.value, th)
        th.set_top_comment(c)
        t = Topic(f, current_user, form.title.data, th)

        db.session.add(th)
        db.session.add(c)
        db.session.add(t)
        db.session.commit()

    return render('/forum/forum.html', f=f, form=form)

@app.route('/forum/<forum:f>/<topicslug:t>')
def forum_topic(f, t):
    return render('/forum/topic.html', f=f, t=t)
